﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinProgressBar;

namespace WindowsFormsApplication15
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            BindingList<int?> newList = new BindingList<int?>();
            newList.Add(0);
            newList.Add(null);
            newList.Add(null);
            newList.Add(10);
            newList.Add(30);
            newList.Add(300);

            ultraGrid1.DataSource = newList;
        }

        

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns.Add("Unbound");
            e.Layout.Bands[0].Columns["Unbound"].DataType = typeof(int);
            e.Layout.Bands[0].Columns["Unbound"].EditorComponent = ultraProgressBar1;
            //e.Layout.Bands[0].Columns[1].Hidden = true;

            e.Layout.Bands[0].Columns.Add("NullableUnbound");
            e.Layout.Bands[0].Columns["NullableUnbound"].DataType = typeof(int?);
            var ucce = new UltraControlContainerEditor();
            ucce.RenderingControl = nullableProgressBar1;
            e.Layout.Bands[0].Columns["NullableUnbound"].EditorComponent = ucce;
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            e.Row.Cells["NullableUnbound"].Value = e.Row.Cells[1].Value;
            if (e.Row.Cells[1].Value == null)
            {
                e.Row.Cells["Unbound"].Value = 0;
            }
            else
            {
                e.Row.Cells["Unbound"].Value = e.Row.Cells[1].Value;
            }
        }
    }
}
